/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.ui.jsp;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import com.silverwrist.venice.ui.*;

public class UtilTextTag extends VeniceBodyTagSupport
{
  /*--------------------------------------------------------------------------------
   * Overrides from class BodyTagSupport
   *--------------------------------------------------------------------------------
   */

  public int doAfterBody() throws JspException
  {
    Tag tag = this.getParent();
    while (tag!=null)
    { // see if the closest ancestor is any tag we recognize
      if (tag instanceof UtilMenuHeaderItemTag)
      { // found a UtilMenuHeaderItemTag
	UtilMenuHeaderItemTag menu_hdr = (UtilMenuHeaderItemTag)tag;
	menu_hdr.setText(getBodyContent().getString().trim());
	return SKIP_BODY;

      } // end if

      if (tag instanceof UtilXLinkTag)
      { // found a UtilXLinkTag
	UtilXLinkTag xlink = (UtilXLinkTag)tag;
        xlink.setText(getBodyContent().getString().trim());
        return SKIP_BODY;

      } // end if

      tag = tag.getParent();  // move to next ancestor and try again

    } // end while

    throw new JspTagException("<util:text/> tag not nested inside a compatible tag!");

  } // end doAfterBody

} // end class UtilTextTag
